代码随想录算法训练营第五十九天|503.下一个更大元素II 42. 接雨水

目录

LeeCode 503.下一个更大元素II 

LeeCode 42. 接雨水

暴力解法

优化双指针法

单调栈法


LeeCode 503.下一个更大元素II 

503. 下一个更大元素 II - 力扣(LeetCode)

【思路】 

相较于前两道题目,这道题目将数组改为循环数组,思路与之前大致相同。

【代码】

class Solution {
public:
    vector nextGreaterElements(vector& nums) {
    	vector result(nums.size(), -1);
		if (nums.size() == 0) return result;
		stack st;
		st.push(0);
		for (int i = 0; i < nums.size() * 2; i++) {
			if (nums[i % nums.size()] <= nums[st.top()]) st.push(i % nums.size());
			else {
				while (!st.empty() && nums[i % nums.size()] > nums[st.top()]) {
					result[st.top()] = nums[i % nums.size()];
					st.pop();
				}
				st.push(i % nums.size());
			}
		}  
		return result;
    }
};

LeeCode 42. 接雨水

42. 接雨水 - 力扣(LeetCode)

暴力解法

【思路】

按列计算,每一列雨水的高度 = min(左侧最高柱子的高度, 右侧最高柱子的高度) - 该列柱子高度;从头遍历所有列,首尾的柱子不接水。如下图所示。

代码随想录算法训练营第五十九天|503.下一个更大元素II 42. 接雨水_第1张图片

 【代码】

class Solution {
public:
    int trap(vector& height) {
    	int sum = 0;
    	for (int i = 0; i < height.size(); i++) {
    		if (i == 0 || i == height.size() - 1) continue;
    		int rheight = height[i];
    		int lheight = height[i];
    		for (int r = i + 1; r < height.size(); r++) {
    			if (height[r] > rheight) rheight = height[r];
			}
			for (int l = i - 1; l >= 0; l--) {
    			if (height[l] > lheight) lheight = height[l];
			}
			int h = min(lheight, rheight) - height[i];
			if (h > 0) sum += h;
		}
        return sum;
    }
};

时间复杂度:O(n²)                                              空间复杂度:O(1) 

优化双指针法

【思路】

使用双指针遍历,把每一个位置的左边最高高度和右边最高高度分别记录在数组上; 从左向右遍历:maxLeft[i] = max(height[i], maxLeft[i - 1]); 从右向左遍历:maxRight[i] = max(height[i], maxRight[i + 1]);

【代码】

class Solution {
public:
    int trap(vector& height) {
    	if (height.size() <= 2) return 0;;
    	vector maxleft(height.size(), 0);
    	vector maxright(height.size(), 0);
    	int size = maxright.size();
    	maxleft[0] = height[0];
    	for (int i = 1; i < size; i++) {
    		maxleft[i] = max(height[i], maxleft[i - 1]);
		}
		maxright[size - 1] = height[size - 1];
		for (int i = size - 2; i >= 0; i--) {
			maxright[i] = max(height[i], maxright[i + 1]);
		}
		int sum = 0;
		for (int i = 0; i < size; i++) {
			int count = min(maxleft[i], maxright[i]) - height[i];
			if (count > 0) sum += count; 
		}
		return sum;
    }
};

单调栈法

【思路】

按行计算,从栈顶到栈底递增,柱子高度大于栈顶元素时出现凹槽,栈顶元素为凹槽底部的柱子,栈顶第二个元素是凹槽左边的柱子,添加的元素是凹槽右边的柱子。遇到高度相同的柱子时,更新下标,用最右边的柱子来计算宽度。栈内存储柱子的下标,对应的高度即为height[stack.top()]。

代码随想录算法训练营第五十九天|503.下一个更大元素II 42. 接雨水_第2张图片

 【代码】

class Solution {
public:
    int trap(vector& height) {
    	stack st;
    	int sum = 0;
    	st.push(0);
    	for (int i = 1; i < height.size(); i++) {
    		while(!st.empty() && height[i] > height[st.top()]) {
    			int mid = st.top();
    			st.pop();
    			if (!st.empty()) {
                    //求雨水高度
    				int h = min(height[st.top()], height[i]) - height[mid];
                    //求雨水宽度
    				int w = i - st.top() - 1;
    				sum += h * w;
				}
			}
			st.push(i);
		}
		return sum;
    }
};

你可能感兴趣的:(LeeCode刷题,leetcode,单调栈,c++)